//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;

namespace DelegatesAndEvents
{
	delegate void DelegateCallback();
	class DelegateRemoval
	{
		static void ACallback()
		{
			Console.WriteLine("ACallback()");
		}
		static void BCallback()
		{
			Console.WriteLine("BCallback()");
		}
		static void CCallback()
		{
			Console.WriteLine("CCallback()");
		}
		static void Main(string[] args)
		{
			DelegateCallback ad = new DelegateCallback(ACallback);
			DelegateCallback bd = new DelegateCallback(BCallback);
			DelegateCallback cd = new DelegateCallback(CCallback);

			DelegateCallback dd = ad;
			dd += bd;
			dd += cd;

			Delegate [] da = dd.GetInvocationList();
			foreach(Delegate d in da)
			{
				Console.WriteLine("{0} {1}", d.Target, d.Method);
			}

			dd = (DelegateCallback)Delegate.Remove(dd, cd);
			da = dd.GetInvocationList();
			foreach(Delegate d in da)
			{
				Console.WriteLine("{0} {1}", d.Target, d.Method);
			}

			dd += cd;
			dd += cd;
			dd = (DelegateCallback)Delegate.Remove(dd, cd);
			da = dd.GetInvocationList();
			foreach(Delegate d in da)
			{
				Console.WriteLine("{0} {1}", d.Target, d.Method);
			}

		}
	}
}
