//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Runtime.Serialization.Formatters.Soap;
using System.IO;

namespace DelegatesAndEvents
{
	delegate void DelegateCallback();
	[Serializable]
	class A
	{
		public void ACallback()
		{
			Console.WriteLine("A.ACallback()");
		}
		public void BCallback()
		{
			Console.WriteLine("A.BCallback()");
		}
		public void CCallback()
		{
			Console.WriteLine("A.CCallback()");
		}
	}
	class DelegateSerialization
	{
		static void ACallback()
		{
			Console.WriteLine("ACallback()");
		}
		static void Main(string[] args)
		{
			DelegateCallback ad = new DelegateCallback(ACallback);

			Console.WriteLine("{0} {1}", ad.Target, ad.Method);

			Stream streamWrite = File.Create("static-delegate.xml");
			SoapFormatter soapWrite = new SoapFormatter();
			soapWrite.Serialize(streamWrite, ad);
			streamWrite.Close();

			Stream streamRead = File.OpenRead("static-delegate.xml");
			SoapFormatter soapRead = new SoapFormatter();
			DelegateCallback bd = (DelegateCallback)soapRead.Deserialize(streamRead);

			Console.WriteLine("{0} {1}", bd.Target, bd.Method);
			Console.WriteLine("Equals {0}", ad == bd);
			ad();
			bd();
			streamRead.Close();

			A a = new A();
			ad = new DelegateCallback(a.ACallback);

			Console.WriteLine("{0} {1}", ad.Target, ad.Method);
			streamWrite = File.Create("instance-delegate.xml");
			soapWrite = new SoapFormatter();
			soapWrite.Serialize(streamWrite, ad);
			streamWrite.Close();

			streamRead = File.OpenRead("instance-delegate.xml");
			soapRead = new SoapFormatter();
			bd = (DelegateCallback)soapRead.Deserialize(streamRead);

			Console.WriteLine("{0} {1}", bd.Target, bd.Method);
			Console.WriteLine("Equals {0}", ad == bd);
			ad();
			bd();
			streamRead.Close();

		}
	}
}
