//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
// FunctionObjects.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>
#include <vector>
#include <algorithm>

template <class T>
int comparefunc (const T& a, const T& b)
{
     if(a < b) return -1;
	 else if(a == b) return 0;
	 else return 1;
}


template <class T> struct compareobj {
public:
  int operator () (T a, T b)
   { 
     if(a < b) return -1;
	 else if(a == b) return 0;
	 else return 1;
   }
};


int _tmain(int argc, _TCHAR* argv[])
{
	compareobj<int> mycompare;

	int result  = mycompare(1,2);
	if(result < 0)
		std::cout << _T("less") << std::endl;
	else if(result == 0)
		std::cout << _T("equal") << std::endl;
	else
		std::cout << _T("more") << std::endl;

	result  = comparefunc(1,2);
	if(result < 0)
		std::cout << _T("less") << std::endl;
	else if(result == 0)
		std::cout << _T("equal") << std::endl;
	else
		std::cout << _T("more") << std::endl;

	std::vector<int> v;
	v.push_back(1);
	v.push_back(2);
	std::sort(v.begin(), v.end(), mycompare);
	std::vector<int>::const_iterator iti;
	for(iti = v.begin(); iti < v.end(); iti++)
		std::cout << *iti << std::endl;

	std::vector<double> d;
	d.push_back(1.0);
	d.push_back(1.1);
	d.push_back(1.2);
	d.push_back(1.3);
	std::sort(d.begin(), d.end(), mycompare);
	std::vector<double>::const_iterator itd;
	for(itd = d.begin(); itd < d.end(); itd++)
		std::cout << *itd << std::endl;

	return 0;
}

