//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Threading;
using System.Diagnostics;

namespace ThreadPoolTest
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class ThreadPoolTestForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button startButton;
		private System.Windows.Forms.TextBox appDomainCountTextBox;
		private int appDomainCount;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ThreadPoolTestForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			appDomainCount = 0;

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.appDomainCountTextBox = new System.Windows.Forms.TextBox();
			this.startButton = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// appDomainCountTextBox
			// 
			this.appDomainCountTextBox.Location = new System.Drawing.Point(133, 10);
			this.appDomainCountTextBox.Name = "appDomainCountTextBox";
			this.appDomainCountTextBox.ReadOnly = true;
			this.appDomainCountTextBox.Size = new System.Drawing.Size(128, 22);
			this.appDomainCountTextBox.TabIndex = 1;
			this.appDomainCountTextBox.Text = "";
			// 
			// startButton
			// 
			this.startButton.Location = new System.Drawing.Point(10, 10);
			this.startButton.Name = "startButton";
			this.startButton.Size = new System.Drawing.Size(96, 28);
			this.startButton.TabIndex = 0;
			this.startButton.Text = "Start";
			this.startButton.Click += new System.EventHandler(this.OnStart);
			// 
			// ThreadPoolTestForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
			this.ClientSize = new System.Drawing.Size(336, 56);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.appDomainCountTextBox,
																		  this.startButton});
			this.Name = "ThreadPoolTestForm";
			this.Text = "Asynchronous Callback Test";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new ThreadPoolTestForm());
		}

		private void StartNewAppDomain()
		{
			try
			{
				Debug.WriteLine("Starting with thread ID: " + Convert.ToString(Thread.CurrentThread.GetHashCode()));

				string appDomainName = "RemoteDomain" + Convert.ToString(appDomainCount);
				// Set ApplicationBase to the current directory

				AppDomainSetup info = new AppDomainSetup();

				info.ApplicationBase = "file:\\\\" + System.Environment.CurrentDirectory;

				// Create an application domain with null evidence

				AppDomain dom = AppDomain.CreateDomain(appDomainName, null, info);

				// Tell the AppDomain to execute the assembly

				dom.ExecuteAssembly("DiningPhilosophers.exe");

				// Clean up by unloading the application domain

				AppDomain.Unload(dom);  

				Interlocked.Decrement(ref appDomainCount);
				appDomainCountTextBox.Text = Convert.ToString(appDomainCount);
				appDomainCountTextBox.Refresh();

				Debug.WriteLine("Exiting with thread ID: " + Convert.ToString(Thread.CurrentThread.GetHashCode()));
			}
			catch(Exception e)
			{
				Debug.WriteLine(e.ToString());
			}
		}
		private void OnStart(object sender, System.EventArgs e)
		{
			Interlocked.Increment(ref appDomainCount);
			appDomainCountTextBox.Text = Convert.ToString(appDomainCount);
			appDomainCountTextBox.Refresh();
			Thread t = new Thread(new ThreadStart(StartNewAppDomain));
			t.Start();
			// StartNewAppDomain();
		}
	}
}
